precision mediump float;

// input from glUniform's
uniform mat4 u_projection_matrix;
uniform mat4 u_model_matrix;
uniform mat4 u_light_matrix;

// input from glVertexAttribPointer (for each vertex)
layout (location=0) in vec3 i_position;
layout (location=1) in vec3 i_normal;
layout (location=2) in vec2 i_uv;

// output to fragment shader
out vec3 position;       // world coordinates
out vec4 position_light; // light-space coordinates
out vec3 normal;         // world coordinates (normalized)
out vec2 uv;

void main() {

#if 1
    vec4 pw = u_model_matrix*vec4(i_position,1);
    vec3 nw = transpose(inverse(mat3(u_model_matrix)))*i_normal;
    gl_Position = u_projection_matrix*pw;

    position = pw.xyz;
    position_light = u_light_matrix*pw;
    normal = normalize(nw);
    uv = i_uv;
#else
    vec4 pw = u_model_matrix*vec4(i_position,1);
    vec4 nw = u_model_matrix*vec4(i_normal,1);
    gl_Position = u_projection_matrix*pw;

    position = pw.xyz;
    position_light = u_light_matrix*pw;
    normal = normalize(nw.xyz);
    uv = i_uv;
#endif
}

